Codeforces Round 102(EDU) D Program ---RMQ - ST表

D. Program

You are given a program that consists of n instructions. Initially a single variable x is assigned to 0. Afterwards, the instructions are of two types:
increase x by 1;
decrease x by 1.
You are given m queries of the following format: query l r — how many
distinct values is x assigned to if all the instructions between the
l-th one and the r-th one inclusive are ignored and the rest are
executed without changing the order?

Input The first line contains a single integer t (1≤t≤1000) — the
number of testcases. Then the description of t testcases follows. The
first line of each testcase contains two integers n and m
(1≤n,m≤2⋅105) — the number of instructions in the program and the
number of queries. The second line of each testcase contains a program
— a string of n characters: each character is either ‘+’ or ‘-’ —
increment and decrement instruction, respectively. Each of the next m
lines contains two integers l and r (1≤l≤r≤n) — the description of the
query. The sum of n over all testcases doesn’t exceed 2⋅105. The sum
of m over all testcases doesn’t exceed 2⋅105.
Output
For each testcase print m integers — for each query l, r print the number of distinct values variable x is assigned to if all the instructions between the l-th one and the r-th one inclusive are ignored and the rest are executed without changing the order.

题意:一个有‘+’和‘-’组成的字符串 初始x的值为0,然后开始执行字符串,遇到‘+’ x的值+1,遇到‘-’ x的值-1 ,每次给你一个区间[L,R],忽略区间内的字符,执行其他部分,问每次执行后,会出现多少个不同的数字

思路:忽略[L,R]内的字符串,保留了两部分[1,L] 和 [R,N] 因为x的值每次都是+1或者-1,所以x的值一定都是连续出现的,区间内的min–max之间的所有值都会全部出现,讲所有字符串执行得到num数组然后用RMQ维护一下,ST表查询两边区间的最大最小值,得到两个答案区间范围,很简单可以找到右边忽略区间[L,R]区间后的真实值 然后将两个区间取并集,区间长度就是答案。

注意处理边界L=1和R=N;

#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int maxn=2e5+7;
int num[maxn],n,m,dp1[maxn][20],dp2[maxn][20];
void RMQ()
{
    for(int i=1;i<=n;i++)
        dp1[i][0]=dp2[i][0]=num[i];
    for(int j=1;(1<<j)<=n;j++)
    {
        for(int i=1;i+(1<<j)-1<=n;i++)
        {
            dp1[i][j]=max(dp1[i][j-1],dp1[i+(1<<(j-1))][j-1]);
            dp2[i][j]=min(dp2[i][j-1],dp2[i+(1<<(j-1))][j-1]);
        }
    }
}
int ans1=0,ans2=0;
void ST(int l,int r)
{
    int k=0;
    while((1<<(k+1))<=r-l+1)
    k++;
    ans1=max(dp1[l][k],dp1[r-(1<<k)+1][k]);
    ans2=min(dp2[l][k],dp2[r-(1<<k)+1][k]);
}
char s[maxn];
int main()
{
	int T,q;
	int l,r;
	cin>>T;
	while(T--)
	{
		cin>>n>>q;
		cin>>s+1;
		int cnt=0;
		for(int i=1;i<=n;i++)
		{
			if(s[i]=='+')
				num[i]=(++cnt);
			else num[i]=(--cnt);
		}
		RMQ();
		while(q--)
		{
			cin>>l>>r;
			int w1,w2,w3,w4;//记录最大最小值 
			ans1=0,ans2=0;
			if(l-1>=1)
				ST(1,l-1);
			w1=max(ans1,0);
			w2=min(ans2,0);
			if(r+1<=n)
			{
				ST(r+1,n);
				int t;
				if(s[r+1]=='+')
				{
					int t=num[r+1]-1;
	
				}
				else{
					int t=num[r+1]+1;
				}
				t=num[r]-num[l-1];
				ans1=ans1-t;
				ans2=ans2-t;
			}
				
			else ans1=0,ans2=0;
			//w1-w2  ans1-ans2
			int ppt;
			if(ans2>w1||w2>ans1)
				ppt=(w1-w2+1)+(ans1-ans2+1);
			else {
				ppt=max(w1,ans1)-min(w2,ans2)+1;
			}
			cout<<ppt<<endl;
		}
		
	}
}

在这里插入图片描述

还剩几分钟写出来这道题,看到这运行时间感觉会被HACK掉,结果还是活下来了,完结撒花,早日上绿~~

CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值